.Dd March 26, 2012
.Dt CUTECHESS-CLI 6
.Os
.Sh NAME
.Nm cutechess-cli
.Nd Automate chess engine tournaments
.Sh SYNOPSIS
.Nm
.Fl engine Ar engine-options
.Fl engine Ar engine-options
.Op Fl engine Ar engine-options ...
.Op options
.Sh DESCRIPTION
The
.Nm
utility automates chess engine tournaments.
.Pp
Its options are as follows:
.Bl -tag -width Ds
.It Fl engine Ar engine-options
Add an engine defined by
.Ar engine-options
to the tournament.
See
.Sx Engine Options .
.It Fl each Ar engine-options
Apply
.Ar engine-options
to each engine in the tournament.
See
.Sx Engine Options .
.It Fl variant Ar variant
Set the chess variant, where
.Ar variant
is one of:
.Cm atomic ,
.Cm capablanca ,
.Cm caparandom ,
.Cm crazyhouse ,
.Cm fischerandom ,
.Cm gothic ,
.Cm loser
or
.Cm standard
(default).
.It Fl concurrency Ar n
Set the maximum number of concurrent games to
.Ar n .
.It Fl draw Ar n Ar score
Adjudicate the game as draw if the score of both engines is within
.Ar score
centipawns from zero after
.Ar n
full moves have been played.
.It Fl resign Ar n Ar score
Adjudicate the game as a loss if an engine's score is at least
.Ar score
centipawns below zero for at least
.Ar n
consecutive moves.
.It Fl tournament Ar type
Set the tournament type, where
.Ar type
is either
.Cm round-robin
(default) or
.Cm gauntlet .
.It Fl event Ar arg
Set the event name to
.Ar arg .
.It Fl games Ar n
Play
.Ar n
games per encounter.
This value should be set to an even number in tournaments with more than two
players to make sure that each player plays an equal number of games with white
and black pieces.
.It Fl rounds Ar n
Multiply the number of rounds to play by
.Ar n .
For two-player tournaments this option should be used to set the total
number of games to play.
.It Fl ratinginterval Ar n
Set the interval for printing the ratings to
.Ar n
games.
.It Fl debug
Display all engine input and output.
.It Fl pgnin Ar file
Use
.Ar file
as the opening book in PGN format.
.It Fl pgndepth Ar plies
Set the maximum depth for the PGN input.
.It Fl pgnout Ar file Bq Cm min
Save the games to
.Ar file
in PGN format. Use the
.Cm min
argument to save in a minimal PGN format.
.It Fl recover
Restart crashed engines instead of stopping the game.
.It Fl repeat
Play each opening twice so that both players get to play it on both
sides.
.It Fl site Ar arg
Set the site / location to
.Ar arg .
.It Fl srand Ar seed
Set the random seed for the book move selector.
.It Fl wait Ar n
Wait
.Ar n
milliseconds between games. The default is 0.
.It Fl -version
Display the version information.
.It Fl -help
Display help information.
.It Fl -engines
Display a list of configured engines and exit.
.El
.Ss Engine Options
.Bl -tag -width Ds
.It Ic conf Ns = Ns Ar arg
Use an engine with the name
.Ar arg
from engine configuration file.
.It Ic name Ns = Ns Ar arg
Set the name to
.Ar arg .
.It Ic cmd Ns = Ns Ar arg
Set the command to
.Ar arg .
.It Ic dir Ns = Ns Ar arg
Set the working directory to
.Ar arg .
.It Ic proto Ns = Ns [ Cm uci | Cm xboard  Ns ]
Set the chess protocol.
.It Ic tc Ns = Ns [ Ns Ar tcformat | Cm inf Ns ]
Set the time control.
The format is moves/time+increment,
where
.Ar moves
is the number of moves per tc,
.Ar time
is time per tc (either seconds or minutes:seconds),
and
.Ar increment
is the time increment per move in seconds.
.Pp
Infinite time control can be set with
.Cm inf .
.It Ic option. Ns Ar name Ns = Ns Ar value
Set custom engine option.
.It Ic arg Ns = Ns Ar arg
Pass
.Ar arg
to the engine as a command line argument.
.It Ic initstr Ns = Ns Ar arg
Send
.Ar arg
to the engine's standard input at startup.
.It Ic restart Ns = Ns [ Cm auto | Cm on | Cm off Ns ]
Set the engine restart mode.
.Cm auto
means the engine decides whether to restart (default),
.Cm on
means the engine is always restarted between games and
.Cm off
means the engine is never restarted between games.
.It Ic st Ns = Ns Ar n
Set the time limit for each move to
.Ar n
seconds.
This option cannot be used in combination with the
.Ic tc
option.
.It Ic timemargin Ns = Ns Ar n
Let engines go
.Ar n
milliseconds over the time limit.
.It Ic book Ns = Ns Ar file
Use
.Ar file
(Polyglot book file) as the opening book.
.It Ic bookdepth Ns = Ns Ar n
Set the maximum book depth (in fullmoves) to
.Ar n .
.It Ic whitepov
Invert the engine's scores when it plays black.
This option should be used with engines that always report scores from white's
perspective.
.It Ic depth Ns = Ns Ar plies
Set the search depth limit.
.It Ic nodes Ns = Ns Ar count
Set the node count limit.
.El
.Sh EXAMPLES
Play ten games between two Sloppy engines with a time control of 40
moves in 60 seconds:
.Pp
.Dl $ cutechess-cli \-engine name=Sloppy -engine name=Sloppy -each cmd=sloppy proto=xboard tc=40/60 -rounds 10
.Pp
Play a single game between Atak and Glaurung engines with a time
control of 40 moves in one minute and 30 seconds with one second
increment:
.Pp
.Dl $ cutechess-cli \-engine name=Atak cmd=Atak32.exe dir=C:\eatak proto=xboard -engine cmd=glaurung proto=uci option.Threads=1 -both tc=40/1:30+1
.Bl -bullet
.It
Use the name=Atak parameter because it's a Xboard protocol 1 engine
and doesn't tell its name.
.It
Use the dir=C:\eatak parameter to point the location of the executable.
.It
Glaurung can tell its name and is in the PATH variable so only the
command is needed.
.It
Set Glaurung to use 1 thread.
.It
Set the time control to 40 moves in one minute and 30 seconds with
one second increment.
.El
.Pp
Play a Round-Robin tournament between Fruit, Crafty, Stockfish and
Sloppy:
.Pp
.Dl $ cutechess-cli \-engine conf=Fruit -engine conf=Crafty -engine conf=Stockfish -engine conf=Sloppy -each tc=4 book=book.bin -games 2 -rounds 10 -repeat
.Bl -bullet
.It
Play two games per encounter,
effectively multiplying the number of games by 2.
.It
Play 10 times the minimum amount of rounds (3). So the total number
of rounds to play will be 30, and the total number of games 120.
.It
In each two-game encounter colors are switched between games and the
same opening line is played in both games.
.El
.Sh SEE ALSO
.Xr engines.json 5
.Sh AUTHORS
The
.Nm
utility was written by
.An Ilari Pihlajisto ,
.Mt ilari.pihlajisto@mbnet.fi ;
and
.An Arto Jonsson ,
.Mt ajonsson@kapsi.fi .
.Sh RESOURCES
.Bl -bullet
.It
Project page:
.Lk http://github.com/cutechess/cutechess
.It
Mailing list:
.Lk https://list.kapsi.fi/listinfo/cutechess
.El
